//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "GifLZW.hpp"
#include "TIFLZW.hpp"
#include "ImageEnIO.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ImageEnIO"
#pragma link "ImageEnProc"
#pragma link "ImageEnView"
#pragma link "VideoCap"
#pragma link "ImageEnIO"
#pragma link "ImageEnProc"
#pragma link "ImageEnView"
#pragma link "VideoCap"
#pragma link "IEOpenSaveDlg"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
   DefGIF_LZWDECOMPFUNC=GIFLZWDecompress;
   DefGIF_LZWCOMPFUNC=GIFLZWCompress;
   DefTIFF_LZWDECOMPFUNC=TIFFLZWDecompress;
   DefTIFF_LZWCOMPFUNC=TIFFLZWCompress;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
	DisplayVideoSize();
   ComboBox1->ItemIndex=0;
   Edit1->Text=ImageEnVideoView1->RecFileName;
   UpDown1->Position=short(ImageEnVideoView1->RecFrameRate);
}
//---------------------------------------------------------------------------
void TForm1::DisplayVideoSize()
{
	TRect r=ImageEnVideoView1->GetVideoSize();
	Label6->Caption=String(r.Right+1)+'x'+String(r.Bottom+1);
}
//---------------------------------------------------------------------------
// Input A On
void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
	ImageEnVideoView1->ShowVideo=SpeedButton2->Down;
	Button1->Enabled=!SpeedButton2->Down;
   Button2->Enabled=!SpeedButton2->Down;
	SpeedButton3->Enabled=!SpeedButton2->Down;
}
//---------------------------------------------------------------------------
// Input-B ON
void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
{
	ImageEnVideoView2->ShowVideo=SpeedButton3->Down;
	Button3->Enabled=!SpeedButton3->Down;
   Button4->Enabled=!SpeedButton3->Down;
	SpeedButton2->Enabled=!SpeedButton3->Down;
}
//---------------------------------------------------------------------------
// Overlay (A)
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
	ImageEnVideoView1->DisplayMode= CheckBox1->Checked? dmOverlay:dmPreview;
}
//---------------------------------------------------------------------------
// Overlay (B)
void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
	ImageEnVideoView2->DisplayMode= CheckBox2->Checked? dmOverlay:dmPreview;
}
//---------------------------------------------------------------------------
// Freeze (A)
void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
	ImageEnVideoView1->Frozen=SpeedButton1->Down;
}
//---------------------------------------------------------------------------
// Freeze (B)
void __fastcall TForm1::SpeedButton4Click(TObject *Sender)
{
	ImageEnVideoView2->Frozen=SpeedButton4->Down;
}
//---------------------------------------------------------------------------
// Color adjust (B)
void __fastcall TForm1::Button3Click(TObject *Sender)
{
	ImageEnProc2->DoPreviews(ppeColorAdjust);
}
//---------------------------------------------------------------------------
// Effects (B)
void __fastcall TForm1::Button4Click(TObject *Sender)
{
	ImageEnProc2->DoPreviews(ppeEffects);
}
//---------------------------------------------------------------------------
// Color adjust (A)
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	ImageEnProc1->DoPreviews(ppeColorAdjust);
}
//---------------------------------------------------------------------------
// Effects (A)
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	ImageEnProc1->DoPreviews(ppeEffects);
}
//---------------------------------------------------------------------------
// Configure source
void __fastcall TForm1::Button5Click(TObject *Sender)
{
	if(!ImageEnVideoView1->DoConfigureSource())
		MessageDlg("Configure Source dialog not available",mtInformation,TMsgDlgButtons() << mbOK,0);
   else
   	DisplayVideoSize();
}
//---------------------------------------------------------------------------
// Configure format
void __fastcall TForm1::Button6Click(TObject *Sender)
{
   if(!ImageEnVideoView1->DoConfigureFormat())
	   MessageDlg("Configure Format dialog not available",mtInformation,TMsgDlgButtons() << mbOK,0);
   else
   	DisplayVideoSize();
}
//---------------------------------------------------------------------------
// Configure display
void __fastcall TForm1::Button7Click(TObject *Sender)
{
   if(!ImageEnVideoView1->DoConfigureDisplay())
	   MessageDlg("Configure Display dialog not available",mtInformation,TMsgDlgButtons() << mbOK,0);
   else
   	DisplayVideoSize();
}
//---------------------------------------------------------------------------
// Frames to B - OnVideoFrame (A)
void __fastcall TForm1::ImageEnVideoView1VideoFrame(TObject *Sender,
      Graphics::TBitmap *Bitmap)
{
	ImageEnVideoView2->Assign(Bitmap);
   switch(ComboBox1->ItemIndex) {
   	case 1: ImageEnProc2->ConvertToBWOrdered(); break;
      case 2: ImageEnProc2->ConvertToBWThreshold(-1); break;
      case 3: ImageEnProc2->ConvertToGray(); break;
   }
}
//---------------------------------------------------------------------------
// Frames to B
void __fastcall TForm1::SpeedButton5Click(TObject *Sender)
{
	if(SpeedButton5->Down)
		ImageEnVideoView1->OnVideoFrame= ImageEnVideoView1VideoFrame;
   else
		ImageEnVideoView1->OnVideoFrame= NULL;
}
//---------------------------------------------------------------------------
// Save as...
void __fastcall TForm1::Button11Click(TObject *Sender)
{
	if(SaveImageEnDialog1->Execute())
   	ImageEnIO1->SaveToFile(SaveImageEnDialog1->FileName);
}
//---------------------------------------------------------------------------
// Record
void __fastcall TForm1::SpeedButton6Click(TObject *Sender)
{
	if(SpeedButton6->Down) {
   	ImageEnVideoView1->RecFileName=Edit1->Text;
      ImageEnVideoView1->RecFrameRate=UpDown1->Position;
		ImageEnVideoView1->StartRecord();
   } else
   	ImageEnVideoView1->StopRecord();
}
//---------------------------------------------------------------------------
// Compression
void __fastcall TForm1::Button8Click(TObject *Sender)
{
	ImageEnVideoView1->DoConfigureCompression();
}
//---------------------------------------------------------------------------

